/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

    Build: make demo_date
*/
#include "../src/wydate.h"
#include "../src/wy_uty.h"

// Get the time zone string
//
static const WyStr& tz_string(void)
{
static const WyStr tzstr(Wy::local_tzname());
 return tzstr;
}

static WyRet f(void)
try {
 WyRet r;
 WyDate tm(tz_string(),Wy::now());  // Construct to present date

 Wy::cout << "It is now " << Wy::wrd(tm) << '\n';
 Wy::cout << "23 hours latter: " << Wy::wrd(tm+WyTimeSpec(23L*60*60,Wy_Nano()))
          << '\n';

 if((r=tm.set_date(2003,9,9,0,0,0))!=OK) {
   WY_RETURN(r);
 }
 Wy::cout << "Made time: 2003-9-9. Read back= " << Wy::wrd(tm) << '\n';
 
 return(OK);
}
catch(const WyDate::Reply& e) {
 WY_RETURN(e);
}
catch(...) {
 WY_THROW( WyRet() );
};

int main(void)
try {

 WyRet r=f();
 if(r!=OK) {
   WY_THROW(r);
 }

 // Print the result r
 //
 Wy::cout << Wy::wrd(r) << '\n';
 return(0);
}
catch(const WyRet& e) {
 if(e!=OK) {
   Wy::cerr << Wy::wrd(e) << '\n';
 }
 return e->c_repcode();
}
catch(...) {
 Wy::cout << "main caught(...)\n";
 return(-1);
};
