/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Test functions in wynum.h

   Build: chk_anum
*/

#include "wynum.h"
#include <limits>
#include <cstdlib>

#include "wystr.h"   // only for wrd(..)

#include <iostream>
#if WYLIB_VERSION!=30
#error Test code is for WYLIB_VERSION 30
#endif

extern void ck_num(void);
static const char chdr[]=
                  "+---------------+\n"
                  "| main() caught:|\n"
                  "+---------------+\n";
int main(void) throw()
try {
 std::cout << "Checking wynum...\n";

 //for(int i=0; i<100; ++i) 
 ck_num();

 std::cout << "Checked OK\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(const std::exception& e) {
 std::cerr << chdr << "std::exception" << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr << "unknown unwind" << std::endl;
 return(-1);
};

