/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2004

   Build: chk_str
*/

#include "wystr.h"
#include <iostream>

#if WYSTR_VERSION!=30
#error Test code is for WYSTR_VERSION 30
#endif

extern void ck_str(void);

static const std::string chdr(
                  "+---------------+\n"
                  "| main() caught:|\n"
                  "+---------------+\n");
int main(void) throw()
try {
 std::cout << "Checking wystr.h ...\n";
 if(std::string(WyStr::class_name)!="WyStr") {
   WY_THROW(WyRet() );
 }
 //std::cout << "sizeof(WyStr)=" << sizeof(WyStr) << std::endl;

 std::cout << std::dec
           << "  WyStr::min_capacity()= " << WyStr::min_capacity()
           << std::endl;
 std::cout << std::hex
           << "  WyStr::max_capacity()= 0x" << WyStr::max_capacity()
           << std::endl;

 if(std::string().max_size()!=WyStr::max_capacity()) {
   std::cout << std::hex
           << "  std::string().max_size()= 0x" << std::string().max_size()
           << std::endl;
 }
 //std::cout << "  std::string().capacity()= " << std::string().capacity()
 //          << std::endl;
 ck_str();
 std::cout << "Checked OK\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr << "main caught(...)" << std::endl;
 throw;
};
