/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   Test functions in wy_uty.h
*/

#include "wyret.h"
#include "wyregfile.h"
#include "wyfifofile.h"
#include "wy_uty.h"

static void t1(void)
{
 WyFifoFile ff_rd,ff_wr;
 WyRet r;

 if((WyFifoFile::mkpipe(ff_rd,ff_wr))!=OK) {
   WY_THROW(r);
 }

 // basic built-in type (write)
 {
   char ch;
   WyStr str;
   ff_wr << char('a');
   ff_rd >> ch;
   if(ch!='a') {
     WY_THROW( WyRet() );
   }

   ff_wr << (signed char)-123;
   ff_rd >> str;
   if(str!="-123") {
     WY_THROW( WyRet() );
   }
   ff_wr << (signed short)-122;
   ff_rd >> str;
   if(str!="-122") {
     WY_THROW( WyRet() );
   }
   ff_wr << (signed int)-121;
   ff_rd >> str;
   if(str!="-121") {
     WY_THROW( WyRet() );
   }
   ff_wr << (signed long)-120;
   ff_rd >> str;
   if(str!="-120") {
     WY_THROW( WyRet() );
   }
   ff_wr << (signed long long)-119;
   ff_rd >> str;
   if(str!="-119") {
     WY_THROW( WyRet() );
   }

   ff_wr << (unsigned char)123;
   ff_rd >> str;
   if(str!="123") {
     WY_THROW( WyRet() );
   }
   ff_wr << (unsigned short)122;
   ff_rd >> str;
   if(str!="122") {
     WY_THROW( WyRet() );
   }
   ff_wr << (unsigned int)121;
   ff_rd >> str;
   if(str!="121") {
     WY_THROW( WyRet() );
   }
   ff_wr << (unsigned long)120;
   ff_rd >> str;
   if(str!="120") {
     WY_THROW( WyRet() );
   }
   ff_wr << (unsigned long long)119;
   ff_rd >> str;
   if(str!="119") {
     WY_THROW( WyRet() );
   }
   ff_wr << (float)4.5;
   ff_rd >> str;
   if(str!="4.500000") {
     WY_THROW( WyRet() );
   }
   ff_wr << (double)3.5;
   ff_rd >> str;
   if(str!="3.500000") {
     WY_THROW( WyRet() );
   }

   // 
   ff_wr << "23456";
   ff_rd >> ch;
   if(ch!='2') {
     WY_THROW( WyRet() );
   }
   ff_rd >> ch;
   if(ch!='3') {
     WY_THROW( WyRet() );
   }
   ff_rd >> ch;
   if(ch!='4') {
     WY_THROW( WyRet() );
   }
   unsigned char uch;
   ff_rd >> uch;
   if(uch!='5') {
     WY_THROW( WyRet() );
   }
   signed char sch;
   ff_rd >> sch;
   if(sch!='6') {
     WY_THROW( WyRet() );
   }
 }

 // basic built-in type (wrd)
 {
   char ch;
   WyStr str;
   ff_wr << Wy::wrd((char)8);
   ff_rd >> ch;
   if(ch!='8') {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((signed char)'a');
   ff_rd >> str;
   if(str!="97") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((unsigned char)'a');
   ff_rd >> str;
   if(str!="97") {
     WY_THROW( WyRet() );
   }

   ff_wr << Wy::wrd((signed char)-123);
   ff_rd >> str;
   if(str!="-123") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((signed short)-122);
   ff_rd >> str;
   if(str!="-122") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((signed int)-121);
   ff_rd >> str;
   if(str!="-121") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((signed long)-120);
   ff_rd >> str;
   if(str!="-120") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((signed long long)-119);
   ff_rd >> str;
   if(str!="-119") {
     WY_THROW( WyRet() );
   }

   ff_wr << Wy::wrd((unsigned char)123);
   ff_rd >> str;
   if(str!="123") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((unsigned short)122);
   ff_rd >> str;
   if(str!="122") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((unsigned int)121);
   ff_rd >> str;
   if(str!="121") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((unsigned long)120);
   ff_rd >> str;
   if(str!="120") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((unsigned long long)119);
   ff_rd >> str;
   if(str!="119") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((float)4.5);
   ff_rd >> str;
   if(str!="4.500000") {
     WY_THROW( WyRet() );
   }
   ff_wr << Wy::wrd((double)3.5);
   ff_rd >> str;
   if(str!="3.500000") {
     WY_THROW( WyRet() );
   }

   // 
   ff_wr << Wy::wrd((long)234);
   ff_rd >> ch;
   if(ch!='2') {
     WY_THROW( WyRet() );
   }
   ff_rd >> ch;
   if(ch!='3') {
     WY_THROW( WyRet() );
   }
   ff_rd >> ch;
   if(ch!='4') {
     WY_THROW( WyRet() );
   }

   // chk << const void*
   {
     const int stmp[]={0,5,0};
     WyStr tstr(WyCSeg("0x",2));
     if((r=Wy::_catstr(tstr,(unsigned int)stmp,int(16)))!=OK) {
       WY_THROW(r);
     }
     ff_wr << stmp;
     ff_rd >> str;
     if(str!=tstr) {
       WY_THROW( WyRet() );
     }
   }
 }

 // chk >> str
 {
   WyRegFile tmp(__FILE__,O_RDONLY);  // this file
   WyStr str;
   size_t o_cap( str._capacity() );
   const char* o_buf( str.data() );
   if(str.size()!=0) {
     WY_THROW( WyRet() );
   }
   tmp >> str;
   if(   (str.size()!=o_cap)      // not read cap characters
       &&(str._capacity()!=o_cap) // capacity changed
       &&(str.data()!=o_buf)) {   // reallocation occurred
     WY_THROW( WyRet() );
   }
   if(Wy::_strcmp(str.cseg(0,12),WyCSeg("/* Copyright"))!=0) {
     WY_THROW( WyRet() );
   }
   
   for(;;) {
     tmp >> str;
     if(str.size()==0) {
       break;
     }
   }
 }
};

static void t_error(void)
{
  // chk <<(bf,WyStr)
  {
    try {
      WyRegFile tmp;
      tmp << WyStr("kk");
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk <<(bf,WyCSeg)
  {
    try {
      WyRegFile tmp;
      tmp << WyCSeg("kk");
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk <<(bf,const char*)
  {
    try {
      WyRegFile tmp;
      tmp << (const char*)"kk";
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk <<(bf,char*)
  {
    try {
      WyRegFile tmp;
      tmp << (char*)"kk";
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk <<(bf,char)
  {
    try {
      WyRegFile tmp;
      tmp << (char)'a';
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk <<(bf,int)  (there are many, juct pickup one)
  {
    try {
      WyRegFile tmp;
      tmp << (int)1;
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk >>(bf,str)
  {
    try {
      WyRegFile tmp;
      WyStr str;
      tmp << str;
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

  // chk >>(bf,char&)
  {
    try {
      WyRegFile tmp;
      char ch('a');
      tmp << ch;
      WY_THROW( WyRet() );
    }
    catch(const WyByteFlow::Reply& e) {
      if(e!=Wym_EBADF) {
        WY_THROW( WyRet(e) );
      }
      // FALLTHROUGH
    };
  }

};

void ck_uty(void)
{
 t1();
 t_error();
};
