/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   C-library function wrapper

   .libwy library uses c-lib functions through these wrappers.

   .Different wrappers may be in different files.
   (Some clib functions are used directly in some .cpp files, e.g. 
    WySysFile::wy_close(int) is for ::close,...)
*/

#ifndef WY__CFUNC_H__
#define WY__CFUNC_H__
#define WY__CFUNC_VERSION 30

#include "wyreqs.h"
#include <sys/stat.h>
#include <sys/types.h>  // for mode_t

#ifdef WY_DEBUG
extern int wyc__fdcnt;
extern int wyc__fdcnt_max;
#endif

int wyc_open(const char* pathname, int flags);
int wyc_open(const char* pathname, int flags, mode_t mode);
int wyc_creat(const char* pathname, mode_t mode);
int wyc_dup(int oldfd);
int wyc_dup2(int oldfd, int newfd);
int wyc_fstat(int fd, struct stat* buf);
int wyc_stat(const char*, struct stat* buf);
int wyc_fsync(int fd);
int wyc_fdatasync(int fd);
int wyc_isatty(int fd);

#endif
