/* Copyright is licensed by GNU LGPL.                        (I.J. Wang, 2005)

   This file is part of wystr.h
*/

#ifndef WY__NUMSTR_H__
#define WY__NUMSTR_H__
#define WY__NUMSTR_VERSION 30

namespace Wy {
 WyRet _mkstr(WyStr& str, char num);
 WyRet _mkstr(WyStr& str, signed char num);
 WyRet _mkstr(WyStr& str, signed short num);
 WyRet _mkstr(WyStr& str, signed int num);
 WyRet _mkstr(WyStr& str, signed long num);
 WyRet _mkstr(WyStr& str, signed long long num);
 WyRet _mkstr(WyStr& str, unsigned char num);
 WyRet _mkstr(WyStr& str, unsigned short num);
 WyRet _mkstr(WyStr& str, unsigned int num);
 WyRet _mkstr(WyStr& str, unsigned long num);
 WyRet _mkstr(WyStr& str, unsigned long long num);
 WyRet _mkstr(WyStr& str, float num);
 WyRet _mkstr(WyStr& str, double num);

 WyRet _mkstr(WyStr& str, char num,int radix);
 WyRet _mkstr(WyStr& str, signed char num,int radix);
 WyRet _mkstr(WyStr& str, signed short num,int radix);
 WyRet _mkstr(WyStr& str, signed int num,int radix);
 WyRet _mkstr(WyStr& str, signed long num,int radix);
 WyRet _mkstr(WyStr& str, signed long long num,int radix);
 WyRet _mkstr(WyStr& str, unsigned char num,int radix);
 WyRet _mkstr(WyStr& str, unsigned short num,int radix);
 WyRet _mkstr(WyStr& str, unsigned int num,int radix);
 WyRet _mkstr(WyStr& str, unsigned long num,int radix);
 WyRet _mkstr(WyStr& str, unsigned long long num,int radix);
 WyRet _mkstr(WyStr& str, float num,int radix);
 WyRet _mkstr(WyStr& str, double num,int radix);

//-------
 WyRet _mkstr(WyStr& str, char num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, signed char num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, signed short num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, signed int num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, signed long num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, signed long long num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, unsigned char num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, unsigned short num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, unsigned int num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, unsigned long num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, unsigned long long num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, float num,int radix,size_t frdig);
 WyRet _mkstr(WyStr& str, double num,int radix,size_t frdig);

 //
 WyRet _catstr(WyStr& str, char num);
 WyRet _catstr(WyStr& str, signed char num);
 WyRet _catstr(WyStr& str, signed short num);
 WyRet _catstr(WyStr& str, signed int num);
 WyRet _catstr(WyStr& str, signed long num);
 WyRet _catstr(WyStr& str, signed long long num);
 WyRet _catstr(WyStr& str, unsigned char num);
 WyRet _catstr(WyStr& str, unsigned short num);
 WyRet _catstr(WyStr& str, unsigned int num);
 WyRet _catstr(WyStr& str, unsigned long num);
 WyRet _catstr(WyStr& str, unsigned long long num);
 WyRet _catstr(WyStr& str, float num);
 WyRet _catstr(WyStr& str, double num);

 WyRet _catstr(WyStr& str, char num,int radix);
 WyRet _catstr(WyStr& str, signed char num,int radix);
 WyRet _catstr(WyStr& str, signed short num,int radix);
 WyRet _catstr(WyStr& str, signed int num,int radix);
 WyRet _catstr(WyStr& str, signed long num,int radix);
 WyRet _catstr(WyStr& str, signed long long num,int radix);
 WyRet _catstr(WyStr& str, unsigned char num,int radix);
 WyRet _catstr(WyStr& str, unsigned short num,int radix);
 WyRet _catstr(WyStr& str, unsigned int num,int radix);
 WyRet _catstr(WyStr& str, unsigned long num,int radix);
 WyRet _catstr(WyStr& str, unsigned long long num,int radix);
 WyRet _catstr(WyStr& str, float num,int radix);
 WyRet _catstr(WyStr& str, double num,int radix);

//-------
 WyRet _catstr(WyStr& str, char num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, signed char num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, signed short num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, signed int num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, signed long num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, signed long long num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, unsigned char num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, unsigned short num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, unsigned int num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, unsigned long num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, unsigned long long num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, float num,int radix,size_t frdig);
 WyRet _catstr(WyStr& str, double num,int radix,size_t frdig);

 //------------------------------
 WyStr wrd(char num,int radix=10);
 WyStr wrd(signed char num,int radix=10);
 WyStr wrd(signed short num,int radix=10);
 WyStr wrd(signed int num,int radix=10);
 WyStr wrd(signed long num,int radix=10);
 WyStr wrd(signed long long num,int radix=10);
 WyStr wrd(unsigned char num,int radix=10);
 WyStr wrd(unsigned short num,int radix=10);
 WyStr wrd(unsigned int num,int radix=10);
 WyStr wrd(unsigned long num,int radix=10);
 WyStr wrd(unsigned long long num,int radix=10);
 WyStr wrd(float num,int radix=10);
 WyStr wrd(double num,int radix=10);

 WyStr wrd(char num,int radix,size_t frdig);
 WyStr wrd(signed char num,int radix,size_t frdig);
 WyStr wrd(signed short num,int radix,size_t frdig);
 WyStr wrd(signed int num,int radix,size_t frdig);
 WyStr wrd(signed long num,int radix,size_t frdig);
 WyStr wrd(signed long long num,int radix,size_t frdig);
 WyStr wrd(unsigned char num,int radix,size_t frdig);
 WyStr wrd(unsigned short num,int radix,size_t frdig);
 WyStr wrd(unsigned int num,int radix,size_t frdig);
 WyStr wrd(unsigned long num,int radix,size_t frdig);
 WyStr wrd(unsigned long long num,int radix,size_t frdig);
 WyStr wrd(float num,int radix,size_t frdig);
 WyStr wrd(double num,int radix,size_t frdig);
};

#endif
