/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2004
*/

#define WYLIB_SOURCE
#include "wynum.h"

namespace Wy {

template <typename T>
inline T wy__sqrt(T n)
{
 if(n<=1) {
   return(n);
 }

 T s1,s2(n>>1);
 do {
   s1=s2;
   s2=(s1+n/s1)>>1;
 } while(s2<s1);

 return(s1);
};

unsigned char _sqrt(unsigned char n)
{ return wy__sqrt<unsigned char>(n); };
unsigned short _sqrt(unsigned short n)
{ return wy__sqrt<unsigned short>(n); };
unsigned int _sqrt(unsigned int n)
{ return wy__sqrt<unsigned int>(n); };
unsigned long _sqrt(unsigned long n)
{ return wy__sqrt<unsigned long>(n); };
unsigned long long _sqrt(unsigned long long n)
{ return wy__sqrt<unsigned long long>(n); };

}; // End of Wy
